#include "$(appName)-ref.h"
#include "$(appName)-ref_common.h"

static void path_compile(char *(*path_function)(void), const char *res_file_name, char *full_path_out)
{
	char *res_path = path_function();
	if (res_path) {
		snprintf(full_path_out, PATH_MAX, "%s%s", res_path, res_file_name);
		free(res_path);
	}
}

void
compile_resource_path(const char *res_file_name, char *full_path_out)
{
	path_compile(app_get_resource_path, res_file_name, full_path_out);
}

void
compile_data_path(const char *res_file_name, char *full_path_out)
{
	path_compile(app_get_data_path, res_file_name, full_path_out);
}
