#include "view/lock.h"
#include "$(appName)-ref_common.h"
#include "$(appName)-ref.h"
#include "../res/edje/edje_definitions.h"

Evas_Object  *_create_lock(Evas_Object *parent, const char *edje_file_name)
{
	char layout_file_full_path[PATH_MAX] = {0,};

	Evas_Object *lock = elm_layout_add(parent);

	if (!lock) {
		dlog_print(DLOG_ERROR, LOG_TAG, "Failure allocating resource: lock");
		return NULL;
	}

	compile_resource_path(edje_file_name, layout_file_full_path);

	if (!elm_layout_file_set(lock, layout_file_full_path, LOCK_MAIN_GROUP)) {
		dlog_print(DLOG_ERROR, LOG_TAG, "Failure to set layout file: lock");
		evas_object_del(lock);
		lock = NULL;
	}

	return lock;
}
