#include "view/lock.h"
#include "view/swipe_lock.h"
#include "../res/edje/edje_definitions.h"

Evas_Object *
_create_swipe_lock(Evas_Object *parent)
{
	return _create_lock(parent, SWIPE_LOCK_EDJ_FILE_NAME);
}

void
_add_swipe_lock_callbacks(Evas_Object *swipe_lock, Edje_Signal_Cb swipe_drag_cb, Edje_Signal_Cb swipe_drag_end_cb)
{
	elm_layout_signal_callback_add(swipe_lock, "drag", "background", swipe_drag_cb, NULL);
	elm_layout_signal_callback_add(swipe_lock, "mouse,up,1", "background", swipe_drag_end_cb, NULL);
}

void
_del_swipe_lock_callbacks(Evas_Object *swipe_lock, Edje_Signal_Cb swipe_drag_cb, Edje_Signal_Cb swipe_drag_end_cb)
{
	elm_layout_signal_callback_del(swipe_lock, "drag", "background", swipe_drag_cb);
	elm_layout_signal_callback_del(swipe_lock, "mouse,up,1", "background", swipe_drag_end_cb);
}

void
_get_swipe_lock_drag_position(Evas_Object *swipe_lock, double *px, double *py)
{
	Evas_Object *edje = elm_layout_edje_get(swipe_lock);
	edje_object_part_drag_value_get(edje, BACKGROUND_PART, px, py);
}

void
_reset_swipe_lock_drag(Evas_Object *swipe_lock)
{
	elm_layout_signal_emit(swipe_lock, SWIPE_RESET_SIGNAL, SWIPE_RESET_SIGNAL_SOURCE);
}
